diff --git a/modules/tls_mgm/Makefile b/modules/tls_mgm/Makefile
index 947f797db03..646cc945794 100644
--- a/modules/tls_mgm/Makefile
+++ b/modules/tls_mgm/Makefile
@@ -20,6 +20,12 @@ SSL_BUILDER=$(shell \
 endif
 
 ifneq ($(SSL_BUILDER),)
+	VER = $(shell $(SSL_BUILDER) --modversion | \
+	      awk -F. '{print $$1 * 100 + $$2}')
+# test if we have a version higher or equal than 1.1
+ifeq ($(shell test $(VER) -ge 101; echo $$?),0)
+	LIBS += -dl -Bsymbolic
+endif
 	DEFS += $(shell $(SSL_BUILDER) --cflags)
 	LIBS += $(shell $(SSL_BUILDER) --libs)
 else
diff --git a/modules/tls_mgm/tls_mgm.c b/modules/tls_mgm/tls_mgm.c
index 7e91f1bed9d..e0080f28a1d 100644
--- a/modules/tls_mgm/tls_mgm.c
+++ b/modules/tls_mgm/tls_mgm.c
@@ -34,6 +34,9 @@
  *
  */
 
+#define _GNU_SOURCE
+#include <dlfcn.h>
+
 #include <openssl/ui.h>
 #include <openssl/ssl.h>
 #include <openssl/opensslv.h>
@@ -1444,6 +1447,70 @@ static int tls_init_multithread(void)
 
 	return 0;
 }
+#else
+int pthread_mutex_init (pthread_mutex_t *__mutex,
+		const pthread_mutexattr_t *__mutexattr)
+{
+	int ret;
+	pthread_mutexattr_t *attr;
+	pthread_mutexattr_t local_attr;
+	int (*real_pthread_mutex_init)(pthread_mutex_t *,
+			const pthread_mutexattr_t *);
+
+	real_pthread_mutex_init = dlsym(RTLD_NEXT, "pthread_mutex_init");
+	if (!real_pthread_mutex_init)
+		return -1;
+
+	if (__mutexattr)
+		attr = (pthread_mutexattr_t *)__mutexattr;
+	else {
+		ret = pthread_mutexattr_init(&local_attr);
+		if (ret != 0)
+			return ret;
+
+		attr = &local_attr;
+	}
+	ret = pthread_mutexattr_setpshared(attr, PTHREAD_PROCESS_SHARED);
+	if (ret != 0)
+		goto destroy;
+	ret = real_pthread_mutex_init(__mutex, attr);
+destroy:
+	if (attr != __mutexattr)
+		pthread_mutexattr_destroy(attr);
+	return ret;
+}
+
+int pthread_rwlock_init (pthread_rwlock_t *__restrict __rwlock,
+		                const pthread_rwlockattr_t *__restrict __attr)
+{
+	int ret;
+	pthread_rwlockattr_t *attr;
+	pthread_rwlockattr_t local_attr;
+	int (*real_pthread_rwlock_init)(pthread_rwlock_t *,
+			const pthread_rwlockattr_t *);
+
+	real_pthread_rwlock_init = dlsym(RTLD_NEXT, "pthread_rwlock_init");
+	if (!real_pthread_rwlock_init)
+		return -1;
+
+	if (__attr)
+		attr = (pthread_rwlockattr_t *)__attr;
+	else {
+		ret = pthread_rwlockattr_init(&local_attr);
+		if (ret != 0)
+			return ret;
+
+		attr = &local_attr;
+	}
+	ret = pthread_rwlockattr_setpshared(attr, PTHREAD_PROCESS_SHARED);
+	if (ret != 0)
+		goto destroy;
+	ret = real_pthread_rwlock_init(__rwlock, attr);
+destroy:
+	if (attr != __attr)
+		pthread_rwlockattr_destroy(attr);
+	return ret;
+}
 #endif
 
 /*
